Make waf fail if submodules are out of date.
[sfrench/samba-autobuild/.git] / wscript
1 #!/usr/bin/env python
2
3 srcdir = '.'
4 blddir = 'bin'
5
6 APPNAME='samba'
7 VERSION=None
8
9 import sys, os, tempfile
10 sys.path.insert(0, srcdir+"/buildtools/wafsamba")
11 import wafsamba, Options, samba_dist, samba_git, Scripting, Utils, samba_version
12
13
14 samba_dist.DIST_DIRS('.')
15 samba_dist.DIST_BLACKLIST('.gitignore .bzrignore source4/selftest/provisions')
16
17 # install in /usr/local/samba by default
18 Options.default_prefix = '/usr/local/samba'
19
20 # This callback optionally takes a list of paths as arguments:
21 # --with-system_mitkrb5 /path/to/krb5 /another/path
22 def system_mitkrb5_callback(option, opt, value, parser):
23     setattr(parser.values, option.dest, True)
24     value = []
25     for arg in parser.rargs:
26         # stop on --foo like options
27         if arg[:2] == "--" and len(arg) > 2:
28             break
29         value.append(arg)
30     if len(value)>0:
31         del parser.rargs[:len(value)]
32         setattr(parser.values, option.dest, value)
33
34 def set_options(opt):
35     opt.BUILTIN_DEFAULT('NONE')
36     opt.PRIVATE_EXTENSION_DEFAULT('samba4')
37     opt.RECURSE('lib/replace')
38     opt.RECURSE('dynconfig')
39     opt.RECURSE('lib/ldb')
40     opt.RECURSE('selftest')
41     opt.RECURSE('source4/lib/tls')
42     opt.RECURSE('pidl')
43     opt.RECURSE('source3')
44     opt.RECURSE('lib/util')
45     opt.RECURSE('ctdb')
46
47     opt.add_option('--with-system-mitkrb5',
48                    help='enable system MIT krb5 build (includes Samba 4 client and Samba 3 code base).'+
49                         'You may specify list of paths where Kerberos is installed (e.g. /usr/local /usr/kerberos) to search krb5-config',
50                    action='callback', callback=system_mitkrb5_callback, dest='with_system_mitkrb5', default=False)
51
52     opt.add_option('--without-ad-dc',
53                    help='disable AD DC functionality (enables Samba 4 client and Samba 3 code base).',
54                    action='store_true', dest='without_ad_dc', default=False)
55
56     opt.add_option('--with-pie',
57                   help=("Build Position Independent Executables " +
58                         "(default if supported by compiler)"),
59                   action="store_true", dest='enable_pie')
60     opt.add_option('--without-pie',
61                   help=("Disable Position Independent Executable builds"),
62                   action="store_false", dest='enable_pie')
63
64     opt.add_option('--with-relro',
65                   help=("Build with full RELocation Read-Only (RELRO)" +
66                         "(default if supported by compiler)"),
67                   action="store_true", dest='enable_relro')
68     opt.add_option('--without-relro',
69                   help=("Disable RELRO builds"),
70                   action="store_false", dest='enable_relro')
71
72     gr = opt.option_group('developer options')
73
74     opt.tool_options('python') # options for disabling pyc or pyo compilation
75     # enable options related to building python extensions
76
77
78 def configure(conf):
79     version = samba_version.load_version(env=conf.env)
80
81     conf.DEFINE('CONFIG_H_IS_FROM_SAMBA', 1)
82     conf.DEFINE('_SAMBA_BUILD_', version.MAJOR, add_to_cflags=True)
83     conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)
84
85     if Options.options.developer:
86         conf.ADD_CFLAGS('-DDEVELOPER -DDEBUG_PASSWORD')
87         conf.env.DEVELOPER = True
88
89     conf.ADD_EXTRA_INCLUDES('#include/public #source4 #lib #source4/lib #source4/include #include #lib/replace')
90
91     conf.env.replace_add_global_pthread = True
92     conf.RECURSE('lib/replace')
93
94     conf.SAMBA_CHECK_PERL(mandatory=True)
95     conf.find_program('xsltproc', var='XSLTPROC')
96
97     conf.SAMBA_CHECK_PYTHON(mandatory=True, version=(2, 6, 0))
98     conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=True)
99
100     if sys.platform == 'darwin' and not conf.env['HAVE_ENVIRON_DECL']:
101         # Mac OSX needs to have this and it's also needed that the python is compiled with this
102         # otherwise you face errors about common symbols
103         if not conf.CHECK_SHLIB_W_PYTHON("Checking if -fno-common is needed"):
104             conf.ADD_CFLAGS('-fno-common')
105         if not conf.CHECK_SHLIB_W_PYTHON("Checking if -undefined dynamic_lookup is not need"):
106             conf.env.append_value('shlib_LINKFLAGS', ['-undefined', 'dynamic_lookup'])
107
108     if sys.platform == 'darwin':
109         conf.ADD_LDFLAGS('-framework CoreFoundation')
110
111     if int(conf.env['PYTHON_VERSION'][0]) >= 3:
112         raise Utils.WafError('Python version 3.x is not supported by Samba yet')
113
114     conf.RECURSE('dynconfig')
115
116     if conf.CHECK_FOR_THIRD_PARTY():
117         conf.RECURSE('third_party')
118     else:
119         if not conf.CHECK_ZLIB():
120             raise Utils.WafError('zlib development packages have not been found.\nIf third_party is installed, check that it is in the proper place.')
121         else:
122             conf.define('USING_SYSTEM_ZLIB',1)
123
124         if not conf.CHECK_POPT():
125             raise Utils.WafError('popt development packages have not been found.\nIf third_party is installed, check that it is in the proper place.')
126         else:
127             conf.define('USING_SYSTEM_POPT', 1)
128
129     conf.RECURSE('lib/ldb')
130
131     if Options.options.with_system_mitkrb5:
132         conf.PROCESS_SEPARATE_RULE('system_mitkrb5')
133     if not (Options.options.without_ad_dc or Options.options.with_system_mitkrb5):
134         conf.DEFINE('AD_DC_BUILD_IS_ENABLED', 1)
135     # Only process heimdal_build for non-MIT KRB5 builds
136     # When MIT KRB5 checks are done as above, conf.env.KRB5_VENDOR will be set
137     # to the lowcased output of 'krb5-config --vendor'.
138     # If it is not set or the output is 'heimdal', we are dealing with
139     # system-provided or embedded Heimdal build
140     if conf.CONFIG_GET('KRB5_VENDOR') in (None, 'heimdal'):
141         conf.RECURSE('source4/heimdal_build')
142     conf.RECURSE('source4/lib/tls')
143     conf.RECURSE('source4/ntvfs/sysdep')
144     conf.RECURSE('lib/util')
145     conf.RECURSE('lib/util/charset')
146     conf.RECURSE('source4/auth')
147     conf.RECURSE('nsswitch')
148     conf.RECURSE('libcli/smbreadline')
149     conf.RECURSE('lib/crypto')
150     conf.RECURSE('pidl')
151     conf.RECURSE('selftest')
152     if conf.CONFIG_GET('ENABLE_SELFTEST'):
153         conf.RECURSE('lib/nss_wrapper')
154         conf.RECURSE('lib/resolv_wrapper')
155         conf.RECURSE('lib/socket_wrapper')
156         conf.RECURSE('lib/uid_wrapper')
157     conf.RECURSE('source3')
158     conf.RECURSE('lib/texpect')
159     if conf.env.with_ctdb:
160         conf.RECURSE('ctdb')
161
162     conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()
163
164     # gentoo always adds this. We want our normal build to be as
165     # strict as the strictest OS we support, so adding this here
166     # allows us to find problems on our development hosts faster.
167     # It also results in faster load time.
168
169     if not sys.platform.startswith("openbsd"):
170         conf.env.asneeded_ldflags = conf.ADD_LDFLAGS('-Wl,--as-needed', testflags=True)
171
172     if not conf.CHECK_NEED_LC("-lc not needed"):
173         conf.ADD_LDFLAGS('-lc', testflags=False)
174
175     # we don't want PYTHONDIR in config.h, as otherwise changing
176     # --prefix causes a complete rebuild
177     del(conf.env.defines['PYTHONDIR'])
178     del(conf.env.defines['PYTHONARCHDIR'])
179
180     if not conf.CHECK_CODE('#include "tests/summary.c"',
181                            define='SUMMARY_PASSES',
182                            addmain=False,
183                            msg='Checking configure summary'):
184         raise Utils.WafError('configure summary failed')
185
186     if Options.options.enable_pie != False:
187         if Options.options.enable_pie == True:
188                 need_pie = True
189         else:
190                 # not specified, only build PIEs if supported by compiler
191                 need_pie = False
192         if conf.check_cc(cflags='-fPIE', ldflags='-pie', mandatory=need_pie,
193                          msg="Checking compiler for PIE support"):
194             conf.env['ENABLE_PIE'] = True
195
196     if Options.options.enable_relro != False:
197         if Options.options.enable_relro == True:
198             need_relro = True
199         else:
200             # not specified, only build RELROs if supported by compiler
201             need_relro = False
202         if conf.check_cc(cflags='', ldflags='-Wl,-z,relro,-z,now', mandatory=need_relro,
203                          msg="Checking compiler for full RELRO support"):
204             conf.env['ENABLE_RELRO'] = True
205
206     conf.SAMBA_CONFIG_H('include/config.h')
207
208 def etags(ctx):
209     '''build TAGS file using etags'''
210     import Utils
211     source_root = os.path.dirname(Utils.g_module.root_path)
212     cmd = 'rm -f %s/TAGS && (find %s -name "*.[ch]" | egrep -v \.inst\. | xargs -n 100 etags -a)' % (source_root, source_root)
213     print("Running: %s" % cmd)
214     status = os.system(cmd)
215     if os.WEXITSTATUS(status):
216         raise Utils.WafError('etags failed')
217
218 def ctags(ctx):
219     "build 'tags' file using ctags"
220     import Utils
221     source_root = os.path.dirname(Utils.g_module.root_path)
222     cmd = 'ctags --python-kinds=-i $(find %s -name "*.[ch]" | grep -v "*_proto\.h" | egrep -v \.inst\.) $(find %s -name "*.py")' % (source_root, source_root)
223     print("Running: %s" % cmd)
224     status = os.system(cmd)
225     if os.WEXITSTATUS(status):
226         raise Utils.WafError('ctags failed')
227
228
229 # putting this here enabled build in the list
230 # of commands in --help
231 def build(bld):
232     '''build all targets'''
233     samba_version.load_version(env=bld.env, is_install=bld.is_install)
234
235
236 def pydoctor(ctx):
237     '''build python apidocs'''
238     bp = os.path.abspath('bin/python')
239     mpaths = {}
240     modules = ['talloc', 'tdb', 'ldb']
241     for m in modules:
242         f = os.popen("PYTHONPATH=%s python -c 'import %s; print %s.__file__'" % (bp, m, m), 'r')
243         try:
244             mpaths[m] = f.read().strip()
245         finally:
246             f.close()
247     mpaths['main'] = bp
248     cmd = ('PYTHONPATH=%(main)s pydoctor --introspect-c-modules --project-name=Samba '
249            '--project-url=http://www.samba.org --make-html --docformat=restructuredtext '
250            '--add-package bin/python/samba ' + ''.join('--add-module %s ' % n for n in modules))
251     cmd = cmd % mpaths
252     print("Running: %s" % cmd)
253     status = os.system(cmd)
254     if os.WEXITSTATUS(status):
255         raise Utils.WafError('pydoctor failed')
256
257
258 def pep8(ctx):
259     '''run pep8 validator'''
260     cmd='PYTHONPATH=bin/python pep8 -r bin/python/samba'
261     print("Running: %s" % cmd)
262     status = os.system(cmd)
263     if os.WEXITSTATUS(status):
264         raise Utils.WafError('pep8 failed')
265
266
267 def wafdocs(ctx):
268     '''build wafsamba apidocs'''
269     from samba_utils import recursive_dirlist
270     os.system('pwd')
271     list = recursive_dirlist('../buildtools/wafsamba', '.', pattern='*.py')
272
273     cmd='PYTHONPATH=bin/python pydoctor --project-name=wafsamba --project-url=http://www.samba.org --make-html --docformat=restructuredtext'
274     print(list)
275     for f in list:
276         cmd += ' --add-module %s' % f
277     print("Running: %s" % cmd)
278     status = os.system(cmd)
279     if os.WEXITSTATUS(status):
280         raise Utils.WafError('wafdocs failed')
281
282
283 def dist():
284     '''makes a tarball for distribution'''
285     sambaversion = samba_version.load_version(env=None)
286
287     os.system("make -C ctdb/doc")
288     samba_dist.DIST_FILES('ctdb/doc:ctdb/doc', extend=True)
289
290     os.system(srcdir + "/release-scripts/build-manpages-nogit")
291     samba_dist.DIST_FILES('bin/docs:docs', extend=True)
292
293     if sambaversion.IS_SNAPSHOT:
294         # write .distversion file and add to tar
295         if not os.path.isdir(blddir):
296             os.makedirs(blddir)
297         distversionf = tempfile.NamedTemporaryFile(mode='w', prefix='.distversion',dir=blddir)
298         for field in sambaversion.vcs_fields:
299             distveroption = field + '=' + str(sambaversion.vcs_fields[field])
300             distversionf.write(distveroption + '\n')
301         distversionf.flush()
302         samba_dist.DIST_FILES('%s:.distversion' % distversionf.name, extend=True)
303
304         samba_dist.dist()
305         distversionf.close()
306     else:
307         samba_dist.dist()
308
309
310 def distcheck():
311     '''test that distribution tarball builds and installs'''
312     samba_version.load_version(env=None)
313     import Scripting
314     d = Scripting.distcheck
315     d()
316
317 def wildcard_cmd(cmd):
318     '''called on a unknown command'''
319     from samba_wildcard import run_named_build_task
320     run_named_build_task(cmd)
321
322 def main():
323     from samba_wildcard import wildcard_main
324
325     wildcard_main(wildcard_cmd)
326 Scripting.main = main
327
328 def reconfigure(ctx):
329     '''reconfigure if config scripts have changed'''
330     import samba_utils
331     samba_utils.reconfigure(ctx)
332
333
334 if os.path.isdir(os.path.join(srcdir, ".git")):
335     # Check if there are submodules that are checked out but out of date.
336     for submodule, status in samba_git.read_submodule_status(srcdir):
337         if status == "out-of-date":
338             raise Utils.WafError("some submodules are out of date. Please run 'git submodule update'")